diff --git a/contrib/sssd.spec.in b/contrib/sssd.spec.in
index 938c779..b35b2e5 100644
--- a/contrib/sssd.spec.in
+++ b/contrib/sssd.spec.in
@@ -622,6 +622,7 @@ rm -rf $RPM_BUILD_ROOT
 %{_mandir}/man5/sssd.conf.5*
 %{_mandir}/man5/sssd-simple.5*
 %{_mandir}/man5/sssd-sudo.5*
+%{_mandir}/man5/sss_rpcidmapd.5*
 %{_mandir}/man8/sssd.8*
 %{_mandir}/man8/sss_cache.8*
 %{_mandir}/man1/sss_ssh_authorizedkeys.1*
diff --git a/src/man/Makefile.am b/src/man/Makefile.am
index 546e0ad..a92ac0d 100644
--- a/src/man/Makefile.am
+++ b/src/man/Makefile.am
@@ -45,7 +45,9 @@ man_MANS = \
     sssd.8 sssd.conf.5 sssd-ldap.5 \
     sssd-krb5.5 sssd-simple.5 \
     sssd_krb5_locator_plugin.8 sss_groupshow.8 \
-    pam_sss.8 sss_obfuscate.8 sss_cache.8 sss_debuglevel.8 sss_seed.8
+    pam_sss.8 sss_obfuscate.8 sss_cache.8 sss_debuglevel.8 sss_seed.8 \
+    sss_rpcidmapd.5 \
+    $(NULL)
 
 if BUILD_SAMBA
 man_MANS += sssd-ipa.5 sssd-ad.5
diff --git a/src/man/include/seealso.xml b/src/man/include/seealso.xml
index 992e64b..25b4217 100644
--- a/src/man/include/seealso.xml
+++ b/src/man/include/seealso.xml
@@ -83,5 +83,9 @@
             <citerefentry>
                 <refentrytitle>pam_sss</refentrytitle><manvolnum>8</manvolnum>
             </citerefentry>.
+            <citerefentry>
+                <refentrytitle>sss_rpcidmapd</refentrytitle>
+                <manvolnum>5</manvolnum>
+            </citerefentry>
         </para>
     </refsect1>
diff --git a/src/man/sss_rpcidmapd.5.xml b/src/man/sss_rpcidmapd.5.xml
new file mode 100644
index 0000000..e2d0fe9
--- /dev/null
+++ b/src/man/sss_rpcidmapd.5.xml
@@ -0,0 +1,132 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE reference PUBLIC "-//OASIS//DTD DocBook V4.4//EN"
+"http://www.oasis-open.org/docbook/xml/4.4/docbookx.dtd">
+<reference>
+<title>SSSD Manual pages</title>
+<refentry>
+    <refentryinfo>
+        <productname>sss rpc.idmapd plugin</productname>
+        <author>
+            <firstname>Noam</firstname>
+            <surname>Meltzer</surname>
+            <affiliation>
+                <orgname>Primary Data Inc.</orgname>
+            </affiliation>
+            <contrib>Developer (2013-2014)</contrib>
+        </author>
+        <author>
+            <firstname>Noam</firstname>
+            <surname>Meltzer</surname>
+            <contrib>Developer (2014-)</contrib>
+            <email>tsnoam@gmail.com</email>
+        </author>
+    </refentryinfo>
+
+    <refmeta>
+        <refentrytitle>sss_rpcidmapd</refentrytitle>
+        <manvolnum>5</manvolnum>
+        <refmiscinfo class="manual">File Formats and Conventions</refmiscinfo>
+    </refmeta>
+
+    <refnamediv id='name'>
+        <refname>sss_rpcidmapd</refname>
+        <refpurpose>sss plugin configuration directives for rpc.idmapd</refpurpose>
+    </refnamediv>
+
+    <refsect1 id='conf-file'>
+        <title>CONFIGURATION FILE</title>
+        <para>
+            rpc.idmapd configuration file is usually found at
+            <emphasis>/etc/idmapd.conf</emphasis>. See
+            <citerefentry>
+                <refentrytitle>idmapd.conf</refentrytitle>
+                <manvolnum>5</manvolnum>
+            </citerefentry> for more information.
+        </para>
+    </refsect1>
+
+    <refsect1 id='sss-conf-extension'>
+        <title>SSS CONFIGURATION EXTENSION</title>
+        <refsect2 id='enable-sss'>
+            <title>Enable SSS plugin</title>
+            <para>
+                In section <quote>[Translation]</quote>, modify/set
+                <quote>Method</quote> attribute to contain
+                <emphasis>sss</emphasis>.
+            </para>
+        </refsect2>
+        <refsect2 id='sss-conf-sect'>
+            <title>[sss] config section</title>
+            <para>
+                In order to change the default of one of the configuration
+                attributes of the <emphasis>sss</emphasis> plugin listed
+                below you will need to create a config section for it, named
+                <quote>[sss]</quote>.
+            </para>
+            <variablelist>
+                <title>Configuration attributes</title>
+                <varlistentry>
+                    <term>memcache (bool)</term>
+                    <listitem>
+                        <para>
+                            Indicates whether or not to use memcache
+                            optimisation technique.
+                        </para>
+                        <para>
+                            Default: True
+                        </para>
+                    </listitem>
+                </varlistentry>
+            </variablelist>
+        </refsect2>
+    </refsect1>
+
+    <refsect1 id='sssd-integration'>
+        <title>SSSD INTEGRATION</title>
+        <para>
+            The sss plugin requires the <emphasis>NSS Responder</emphasis>
+            to be enabled in sssd.
+        </para>
+        <para>
+            The attribute <quote>use_fully_qualified_names</quote> must be
+            enabled on all domains (NFSv4 clients expect a fully qualified name
+            to be sent on the wire).
+        </para>
+    </refsect1>
+
+    <refsect1 id='example'>
+        <title>EXAMPLE</title>
+        <para>
+            The following example shows a minimal idmapd.conf which makes use of
+            the sss plugin.
+            <programlisting>
+[General]
+Verbosity = 2
+# domain must be synced between NFSv4 server and clients
+# Solaris/Illumos/AIX use "localdomain" as default!
+Domain = default
+
+[Mapping]
+Nobody-User = nfsnobody
+Nobody-Group = nfsnobody
+
+[Translation]
+Method = sss
+</programlisting>
+        </para>
+    </refsect1>
+
+    <refsect1 id='see_also'>
+        <title>SEE ALSO</title>
+        <para>
+            <citerefentry>
+                <refentrytitle>sssd</refentrytitle><manvolnum>8</manvolnum>
+            </citerefentry>,
+            <citerefentry>
+                <refentrytitle>idmapd.conf</refentrytitle>
+                <manvolnum>5</manvolnum>
+            </citerefentry>
+        </para>
+    </refsect1>
+</refentry>
+</reference>