From 36cb9ce967478e8979575183b76f2cade0c6bec1 Mon Sep 17 00:00:00 2001
From: Sergey V. Kovylov <kovylov@kovylovnb.(none)>
Date: Mon, 1 Feb 2010 16:38:40 +0300
Subject: [PATCH] Update suse sssd.spec

---
 contrib/suse/sssd.spec.in |   68 +++++++++++++++++++++++++++++++++++++++++++--
 1 files changed, 65 insertions(+), 3 deletions(-)

diff --git a/contrib/suse/sssd.spec.in b/contrib/suse/sssd.spec.in
index 214387a..eff7ff7 100644
--- a/contrib/suse/sssd.spec.in
+++ b/contrib/suse/sssd.spec.in
@@ -12,6 +12,8 @@ URL: http://fedorahosted.org/sssd/
 Source0: %{name}-%{version}.tar.gz
 BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
 
+%define dhash_version 0.4.0
+
 ### Patches ###
 
 ### Dependencies ###
@@ -19,9 +21,10 @@ BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
 Requires: libldb0 >= 0.9.3
 Requires: libtdb1 >= 1.1.3
 Requires: sssd-client = %{version}-%{release}
+Requires: libdhash = %{dhash_version}-%{release}
 Requires: cyrus-sasl-gssapi
 Requires(post): python
-Requires(preun): aaa_base procps filesystem
+Requires(preun):  aaa_base procps filesystem
 Requires(postun): /sbin/service
 
 %define servicename sssd
@@ -55,6 +58,7 @@ BuildRequires: docbook-xsl-stylesheets
 BuildRequires: krb5-devel
 BuildRequires: python-devel
 
+
 %description
 Provides a set of daemons to manage access to remote directories and
 authentication mechanisms. It provides an NSS and PAM interface toward
@@ -70,10 +74,31 @@ Group: Applications/System
 Provides the libraries needed by the PAM and NSS stacks to connect to the SSSD
 service.
 
+%package -n libdhash
+Summary: Dynamic hash table
+Group: Development/Libraries
+Version: %{dhash_version}
+License: LGPLv3+
+
+%description -n libdhash
+A hash table which will dynamically resize to achieve optimal storage & access
+time properties
+
+%package -n libdhash-devel
+Summary: Development files for libdhash
+Group: Development/Libraries
+Version: %{dhash_version}
+Requires: libdhash = %{dhash_version}-%{release}
+License: LGPLv3+
+
+%description -n libdhash-devel
+A hash table which will dynamically resize to achieve optimal storage & access
+time properties
+
+
 %prep
 %setup -q
 
-
 %build
 NSS_LIBS=-lnss3 \
 KRB5_LIBS=-lkrb5 \
@@ -83,9 +108,10 @@ KRB5_LIBS=-lkrb5 \
     --with-pipe-path=%{pipepath} \
     --with-pubconf-path=%{pubconfpath} \
     --with-init-dir=%{_initrddir} \
+    --enable-nsslibdir=/%{_lib} \
     --without-selinux \
     --with-os=suse \
-    --enable-nsslibdir=/%{_lib}
+    --disable-static
 
 make %{?_smp_mflags}
 
@@ -94,6 +120,14 @@ rm -rf $RPM_BUILD_ROOT
 
 make install DESTDIR=$RPM_BUILD_ROOT
 
+# Remove the example files from the output directory
+# We will copy them directly from the source directory
+# for packaging
+rm -f \
+    $RPM_BUILD_ROOT/usr/share/doc/dhash/README \
+    $RPM_BUILD_ROOT/usr/share/doc/dhash/examples/dhash_example.c \
+    $RPM_BUILD_ROOT/usr/share/doc/dhash/examples/dhash_test.c
+
 # Prepare language files
 /usr/lib/rpm/find-lang.sh $RPM_BUILD_ROOT sss_daemon
 /usr/lib/rpm/find-lang.sh $RPM_BUILD_ROOT sss_client
@@ -108,6 +142,7 @@ install -m400 server/config/etc/sssd.api.d/* $RPM_BUILD_ROOT%{_sysconfdir}/sssd/
 rm -f \
     $RPM_BUILD_ROOT/%{_lib}/libnss_sss.la \
     $RPM_BUILD_ROOT/%{_lib}/security/pam_sss.la \
+    $RPM_BUILD_ROOT/%{_libdir}/libdhash.la \
     $RPM_BUILD_ROOT/%{_libdir}/ldb/memberof.la \
     $RPM_BUILD_ROOT/%{_libdir}/sssd/libsss_ldap.la \
     $RPM_BUILD_ROOT/%{_libdir}/sssd/libsss_proxy.la \
@@ -122,6 +157,11 @@ then
     # Older versions of rpmbuild can only handle one -f option
     echo %{_libdir}/krb5/plugins/libkrb5/sssd_krb5_locator_plugin.so >> sss_daemon.lang
 fi
+for file in `ls $RPM_BUILD_ROOT/%{python_sitelib}/*.egg-info 2> /dev/null`
+do
+    echo %{python_sitelib}/`basename $file` >> sss_daemon.lang
+done
+
 %clean
 rm -rf $RPM_BUILD_ROOT
 
@@ -136,6 +176,7 @@ rm -rf $RPM_BUILD_ROOT
 %{_sbindir}/sss_groupadd
 %{_sbindir}/sss_groupdel
 %{_sbindir}/sss_groupmod
+%{_sbindir}/sss_groupshow
 %{_libexecdir}/%{servicename}/
 %{_libdir}/%{name}/
 %{_libdir}/ldb/memberof.so
@@ -158,6 +199,7 @@ rm -rf $RPM_BUILD_ROOT
 %{_mandir}/man8/sss_groupadd.8*
 %{_mandir}/man8/sss_groupdel.8*
 %{_mandir}/man8/sss_groupmod.8*
+%{_mandir}/man8/sss_groupshow.8*
 %{_mandir}/man8/sss_useradd.8*
 %{_mandir}/man8/sss_userdel.8*
 %{_mandir}/man8/sss_usermod.8*
@@ -172,6 +214,21 @@ rm -rf $RPM_BUILD_ROOT
 /%{_lib}/security/pam_sss.so
 %{_mandir}/man8/pam_sss.8*
 
+%files -n libdhash
+%defattr(-,root,root,-)
+%doc common/dhash/COPYING
+%doc common/dhash/COPYING.LESSER
+%{_libdir}/libdhash.so.1
+%{_libdir}/libdhash.so.1.0.0
+
+%files -n libdhash-devel
+%defattr(-,root,root,-)
+%{_includedir}/dhash.h
+%{_libdir}/libdhash.so
+%{_libdir}/pkgconfig/dhash.pc
+%doc common/dhash/README
+%doc common/dhash/examples
+
 %post
 /sbin/ldconfig
 /sbin/chkconfig --add %{servicename}
@@ -196,6 +253,10 @@ fi
 
 %postun client -p /sbin/ldconfig
 
+%post -n libdhash -p /sbin/ldconfig
+
+%postun -n libdhash -p /sbin/ldconfig
+
 %changelog
 * Mon Sep 28 2009 Sumit Bose <sbose@redhat.com> - 0.6.0-0
 - New upstream release 0.6.0
@@ -236,3 +297,4 @@ fi
 - Small cleanup and fixes in the spec file
 
 * Thu Feb 12 2009 Stephen Gallagher <sgallagh@redhat.com> - 0.1.0-1
+- Initial release (based on version 0.1.0 upstream code)
-- 
1.6.6