From 7ea12351cb40907647a455222bf64e17477928e4 Mon Sep 17 00:00:00 2001
From: Stephen Gallagher <sgallagh@redhat.com>
Date: Tue, 9 Mar 2010 08:08:48 -0500
Subject: [PATCH 4/5] Add ID translation for SSSD 1.1.0

---
 src/po/LINGUAS          |    1 +
 src/po/{nl.po => id.po} |  263 +++++++++++++++++++++++++----------------------
 2 files changed, 139 insertions(+), 125 deletions(-)
 copy src/po/{nl.po => id.po} (68%)

diff --git a/src/po/LINGUAS b/src/po/LINGUAS
index f2c4e4c..c494d06 100644
--- a/src/po/LINGUAS
+++ b/src/po/LINGUAS
@@ -7,4 +7,5 @@ de
 sv
 it
 fr
+id
 
diff --git a/src/po/nl.po b/src/po/id.po
similarity index 68%
copy from src/po/nl.po
copy to src/po/id.po
index a78120e..5823f77 100644
--- a/src/po/nl.po
+++ b/src/po/id.po
@@ -1,33 +1,33 @@
-# translation of sssd.master.sss_daemon.po to Dutch
+# Indonesian Translation of SSSD.
 # Copyright (C) YEAR Red Hat, Inc.
-# This file is distributed under the same license as the PACKAGE package.
-#
-# Richard van der Luit <nippur@fedoraproject.org>, 2009.
+# This file is distributed under the same license as the sssd package.
+# Teguh DC <dheche@songolimo.net>, 2010.
 msgid ""
 msgstr ""
-"Project-Id-Version: sssd.master.sss_daemon\n"
+"Project-Id-Version: sssd\n"
 "Report-Msgid-Bugs-To: sssd-devel@lists.fedorahosted.org\n"
 "POT-Creation-Date: 2010-03-08 17:04-0500\n"
-"PO-Revision-Date: 2009-11-19 12:19+0100\n"
-"Last-Translator: Richard van der Luit <nippur@fedoraproject.org>\n"
-"Language-Team: Dutch <nl@li.org>\n"
+"PO-Revision-Date: 2010-03-09 10:34+0700\n"
+"Last-Translator: Teguh DC <dheche@songolimo.net>\n"
+"Language-Team: Fedora Indonesia <trans-id@lists.fedoraproject.org>\n"
 "MIME-Version: 1.0\n"
 "Content-Type: text/plain; charset=UTF-8\n"
 "Content-Transfer-Encoding: 8bit\n"
-"X-Generator: KBabel 1.11.4\n"
-"Plural-Forms:  nplurals=2; plural=(n != 1);\n"
+"Language: id\n"
+"Plural-Forms: nplurals=1; plural=0;\n"
+"X-Generator: Virtaal 0.5.1\n"
 
 #: config/SSSDConfig.py:39
 msgid "Set the verbosity of the debug logging"
-msgstr ""
+msgstr "Mengatur verbosity dari pencatatan debug"
 
 #: config/SSSDConfig.py:40
 msgid "Include timestamps in debug logs"
-msgstr ""
+msgstr "Sertakan cap waktu di pencatatan debug"
 
 #: config/SSSDConfig.py:41
 msgid "Write debug messages to logfiles"
-msgstr ""
+msgstr "Menulis pesan debug ke berkas log"
 
 #: config/SSSDConfig.py:42
 msgid "Ping timeout before restarting service"
@@ -35,19 +35,19 @@ msgstr ""
 
 #: config/SSSDConfig.py:43
 msgid "Command to start service"
-msgstr ""
+msgstr "Perintah untuk memulai layanan"
 
 #: config/SSSDConfig.py:44
 msgid "Number of times to attempt connection to Data Providers"
-msgstr ""
+msgstr "Jumlah usaha yang dilakukan untuk mencoba koneksi ke Penyedia Data"
 
 #: config/SSSDConfig.py:47
 msgid "SSSD Services to start"
-msgstr ""
+msgstr "Layanan SSSD akan dijalankan"
 
 #: config/SSSDConfig.py:48
 msgid "SSSD Domains to start"
-msgstr ""
+msgstr "Domain SSSD akan dijalankan"
 
 #: config/SSSDConfig.py:49
 msgid "Timeout for messages sent over the SBUS"
@@ -75,19 +75,19 @@ msgstr ""
 
 #: config/SSSDConfig.py:57
 msgid "Users that SSSD should explicitly ignore"
-msgstr ""
+msgstr "Pengguna yang diabaikan secara eksplisit oleh SSSD"
 
 #: config/SSSDConfig.py:58
 msgid "Groups that SSSD should explicitly ignore"
-msgstr ""
+msgstr "Grup yang diabaikan secara eksplisit oleh SSSD"
 
 #: config/SSSDConfig.py:59
 msgid "Should filtered users appear in groups"
-msgstr ""
+msgstr "Haruskah pengguna yang disaring muncul dalam grup"
 
 #: config/SSSDConfig.py:60
 msgid "The value of the password field the NSS provider should return"
-msgstr ""
+msgstr "Nilai kolom kata sandi yang harus dikembalikan oleh penyedia NSS"
 
 #: config/SSSDConfig.py:63
 msgid "How long to allow cached logins between online logins (days)"
@@ -105,27 +105,27 @@ msgstr ""
 
 #: config/SSSDConfig.py:68
 msgid "Identity provider"
-msgstr ""
+msgstr "Penyedia identitas"
 
 #: config/SSSDConfig.py:69
 msgid "Authentication provider"
-msgstr ""
+msgstr "Penyedia otentikasi"
 
 #: config/SSSDConfig.py:70
 msgid "Access control provider"
-msgstr ""
+msgstr "Penyedia kontrol akses"
 
 #: config/SSSDConfig.py:71
 msgid "Password change provider"
-msgstr ""
+msgstr "Penyedia pengubah kata sandi"
 
 #: config/SSSDConfig.py:74
 msgid "Minimum user ID"
-msgstr ""
+msgstr "ID pengguna minimum"
 
 #: config/SSSDConfig.py:75
 msgid "Maximum user ID"
-msgstr ""
+msgstr "ID pengguna maksimum"
 
 #: config/SSSDConfig.py:76
 msgid "Ping timeout before restarting domain"
@@ -162,23 +162,23 @@ msgstr ""
 
 #: config/SSSDConfig.py:86
 msgid "IPA domain"
-msgstr ""
+msgstr "Domain IPA"
 
 #: config/SSSDConfig.py:87
 msgid "IPA server address"
-msgstr ""
+msgstr "Alamat server IPA"
 
 #: config/SSSDConfig.py:88
 msgid "IPA client hostname"
-msgstr ""
+msgstr "Nama host klien IPA"
 
 #: config/SSSDConfig.py:91 config/SSSDConfig.py:118
 msgid "Kerberos server address"
-msgstr ""
+msgstr "Alamat server Kerberos"
 
 #: config/SSSDConfig.py:92 config/SSSDConfig.py:119
 msgid "Kerberos realm"
-msgstr ""
+msgstr "Realm Kerberos"
 
 #: config/SSSDConfig.py:93
 msgid "Authentication timeout"
@@ -206,7 +206,7 @@ msgstr ""
 
 #: config/SSSDConfig.py:105
 msgid "ldap_uri, The URI of the LDAP server"
-msgstr ""
+msgstr "ldap_uri, URI server LDAP"
 
 #: config/SSSDConfig.py:106
 msgid "The default base DN"
@@ -214,7 +214,7 @@ msgstr ""
 
 #: config/SSSDConfig.py:107
 msgid "The Schema Type in use on the LDAP server, rfc2307"
-msgstr ""
+msgstr "Jenis Skema yang digunakan pada server LDAP, rfc2307"
 
 #: config/SSSDConfig.py:108
 msgid "The default bind DN"
@@ -230,39 +230,39 @@ msgstr ""
 
 #: config/SSSDConfig.py:111
 msgid "Length of time to attempt connection"
-msgstr ""
+msgstr "Lamanya waktu untuk mencoba koneksi"
 
 #: config/SSSDConfig.py:112
 msgid "Length of time to attempt synchronous LDAP operations"
-msgstr ""
+msgstr "Lamanya waktu untuk mencoba operasi LDAP yang sinkron"
 
 #: config/SSSDConfig.py:113
 msgid "Length of time between attempts to reconnect while offline"
-msgstr ""
+msgstr "Lamanya waktu antara upaya untuk menyambung kembali saat luring"
 
 #: config/SSSDConfig.py:114
 msgid "file that contains CA certificates"
-msgstr ""
+msgstr "berkas yang berisi sertifikat CA"
 
 #: config/SSSDConfig.py:115
 msgid "Require TLS certificate verification"
-msgstr ""
+msgstr "Membutuhkan verifikasi sertifikat TLS"
 
 #: config/SSSDConfig.py:116
 msgid "Specify the sasl mechanism to use"
-msgstr ""
+msgstr "Tentukan mekanisme sasl yang digunakan"
 
 #: config/SSSDConfig.py:117
 msgid "Specify the sasl authorization id to use"
-msgstr ""
+msgstr "Tentukan id otorisasi sasl yang digunakan"
 
 #: config/SSSDConfig.py:120
 msgid "Kerberos service keytab"
-msgstr ""
+msgstr "Keytab layanan Kerberos"
 
 #: config/SSSDConfig.py:121
 msgid "Use Kerberos auth for LDAP connection"
-msgstr ""
+msgstr "Gunakan otentikasi Kerberos untuk koneksi LDAP"
 
 #: config/SSSDConfig.py:122
 msgid "Follow LDAP referrals"
@@ -286,59 +286,59 @@ msgstr ""
 
 #: config/SSSDConfig.py:129
 msgid "Scope of user lookups"
-msgstr ""
+msgstr "Lingkup pencarian pengguna"
 
 #: config/SSSDConfig.py:130
 msgid "Filter for user lookups"
-msgstr ""
+msgstr "Filter pencarian pengguna"
 
 #: config/SSSDConfig.py:131
 msgid "Objectclass for users"
-msgstr ""
+msgstr "Objectclass untuk pengguna"
 
 #: config/SSSDConfig.py:132
 msgid "Username attribute"
-msgstr ""
+msgstr "Atribut Nama pengguna"
 
 #: config/SSSDConfig.py:133
 msgid "UID attribute"
-msgstr ""
+msgstr "Atribut UID"
 
 #: config/SSSDConfig.py:134
 msgid "Primary GID attribute"
-msgstr ""
+msgstr "Atribut GID Primer"
 
 #: config/SSSDConfig.py:135
 msgid "GECOS attribute"
-msgstr ""
+msgstr "Atribut GECOS"
 
 #: config/SSSDConfig.py:136
 msgid "Home directory attribute"
-msgstr ""
+msgstr "Atribut direktori Home"
 
 #: config/SSSDConfig.py:137
 msgid "Shell attribute"
-msgstr ""
+msgstr "Atribut Shell"
 
 #: config/SSSDConfig.py:138
 msgid "UUID attribute"
-msgstr ""
+msgstr "Atribut UUID"
 
 #: config/SSSDConfig.py:139
 msgid "User principal attribute (for Kerberos)"
-msgstr ""
+msgstr "Atribut utama pengguna (untuk Kerberos)"
 
 #: config/SSSDConfig.py:140
 msgid "Full Name"
-msgstr ""
+msgstr "Nama Lengkap"
 
 #: config/SSSDConfig.py:141
 msgid "memberOf attribute"
-msgstr ""
+msgstr "Atribut memberOf"
 
 #: config/SSSDConfig.py:142
 msgid "Modification time attribute"
-msgstr ""
+msgstr "Atribut waktu modifikasi"
 
 #: config/SSSDConfig.py:145
 msgid "Policy to evaluate the password expiration"
@@ -346,15 +346,15 @@ msgstr ""
 
 #: config/SSSDConfig.py:148
 msgid "Comma separated list of allowed users"
-msgstr ""
+msgstr "Daftar pengguna yang diijinkan dalam format yang dipisahkan koma"
 
 #: config/SSSDConfig.py:149
 msgid "Comma separated list of prohibited users"
-msgstr ""
+msgstr "Daftar pengguna yang tidak diijinkan dalam format yang dipisahkan koma"
 
 #: config/SSSDConfig.py:152
 msgid "Default shell, /bin/bash"
-msgstr ""
+msgstr "Shell default, /bin/bash"
 
 #: config/SSSDConfig.py:153
 msgid "Base for home directories"
@@ -390,27 +390,30 @@ msgstr ""
 #: tools/sss_groupdel.c:83 tools/sss_groupmod.c:113 tools/sss_userdel.c:104
 #: tools/sss_useradd.c:185 tools/sss_groupadd.c:88 tools/sss_usermod.c:128
 msgid "Error initializing the tools\n"
-msgstr ""
+msgstr "Gagal saat menginisialisasi perkakas\n"
 
 #: tools/sss_groupdel.c:92 tools/sss_groupmod.c:121 tools/sss_userdel.c:113
 #: tools/sss_useradd.c:194 tools/sss_groupadd.c:97 tools/sss_usermod.c:137
 msgid "Invalid domain specified in FQDN\n"
-msgstr ""
+msgstr "Domain yang ditentukan dalam FQDN tidak valid\n"
 
 #: tools/sss_groupdel.c:107
 #, c-format
 msgid "Group %s is outside the defined ID range for domain\n"
 msgstr ""
+"Grup %s berada di luar rentang ID yang telah didefinisikan untuk domain\n"
 
 #: tools/sss_groupdel.c:136
 msgid ""
 "No such group in local domain. Removing groups only allowed in local "
 "domain.\n"
 msgstr ""
+"Tidak ada grup seperti itu di domain lokal. Menghapus grup hanya "
+"diperbolehkan dalam domain lokal.\n"
 
 #: tools/sss_groupdel.c:141
 msgid "Internal error. Could not remove group.\n"
-msgstr ""
+msgstr "Kesalahan internal. Tidak dapat menghapus grup.\n"
 
 #: tools/sss_groupmod.c:44
 msgid "Groups to add this group to"
@@ -422,26 +425,30 @@ msgstr ""
 
 #: tools/sss_groupmod.c:48 tools/sss_groupadd.c:43
 msgid "The GID of the group"
-msgstr ""
+msgstr "GID grup"
 
 #: tools/sss_groupmod.c:98
 msgid "Specify group to modify\n"
-msgstr ""
+msgstr "Tentukan grup untuk dimodifikasi\n"
 
 #: tools/sss_groupmod.c:130
 msgid ""
 "Cannot find group in local domain, modifying groups is allowed only in local "
 "domain\n"
 msgstr ""
+"Tidak dapat menemukan grup di domain lokal, memodifikasi grup hanya "
+"diperbolehkan dalam domain lokal\n"
 
 #: tools/sss_groupmod.c:143 tools/sss_groupmod.c:170 tools/sss_useradd.c:203
 #: tools/sss_usermod.c:162 tools/sss_usermod.c:189
 msgid "Internal error while parsing parameters\n"
-msgstr ""
+msgstr "Terjadi kesalahan internal ketika mengurai parameter\n"
 
 #: tools/sss_groupmod.c:151 tools/sss_groupmod.c:178
 msgid "Member groups must be in the same domain as parent group\n"
 msgstr ""
+"Anggota kelompok harus berada dalam domain yang sama sebagaimana kelompok "
+"induknya\n"
 
 #: tools/sss_groupmod.c:159 tools/sss_groupmod.c:186 tools/sss_usermod.c:178
 #: tools/sss_usermod.c:205
@@ -450,227 +457,238 @@ msgid ""
 "Cannot find group %s in local domain, only groups in local domain are "
 "allowed\n"
 msgstr ""
+"Tidak dapat menemukan grup %s di domain lokal, hanya grup dalam domain lokal "
+"yang diperbolehkan\n"
 
 #: tools/sss_groupmod.c:194 tools/sss_groupadd.c:106
 msgid "The selected GID is outside the allowed range\n"
-msgstr ""
+msgstr "GID yang dipilih berada di luar rentang yang diizinkan\n"
 
 #: tools/sss_groupmod.c:222
 msgid "Could not modify group - check if member group names are correct\n"
 msgstr ""
+"Tidak bisa memodifikasi grup - periksa apakah nama grup anggota sudah benar\n"
 
 #: tools/sss_groupmod.c:226
 msgid "Could not modify group - check if groupname is correct\n"
-msgstr ""
+msgstr "Tidak bisa memodifikasi grup - periksa apakah groupname sudah benar\n"
 
 #: tools/sss_groupmod.c:230
 msgid "Transaction error. Could not modify group.\n"
-msgstr ""
+msgstr "Kesalahan transaksi. Tidak bisa memodifikasi grup.\n"
 
 #: tools/sss_userdel.c:46
 msgid "Remove home directory and mail spool"
-msgstr ""
+msgstr "Hapus direktori home, dan spool mail"
 
 #: tools/sss_userdel.c:47
 msgid "Do not remove home directory and mail spool"
-msgstr ""
+msgstr "Jangan hapus direktori home dan spool mail"
 
 #: tools/sss_userdel.c:48
 msgid "Force removal of files not owned by the user"
-msgstr ""
+msgstr "Paksa penghapusan berkas yang tidak dimiliki oleh pengguna"
 
 #: tools/sss_userdel.c:91
 msgid "Specify user to delete\n"
-msgstr ""
+msgstr "Tentukan pengguna yang akan dihapus\n"
 
 #: tools/sss_userdel.c:123 tools/sss_useradd.c:244
 msgid "Cannot set default values\n"
-msgstr ""
+msgstr "Tidak dapat menetapkan nilai default\n"
 
 #: tools/sss_userdel.c:141
 #, c-format
 msgid "User %s is outside the defined ID range for domain\n"
 msgstr ""
+"Pengguna %s berada di luar rentang ID yang telah didefinisikan untuk domain\n"
 
 #: tools/sss_userdel.c:172
 msgid "Not removing home dir - not owned by user\n"
-msgstr ""
+msgstr "Tidak menghapus home dir - tidak dimiliki oleh pengguna\n"
 
 #: tools/sss_userdel.c:174
 #, c-format
 msgid "Cannot remove homedir: %s\n"
-msgstr ""
+msgstr "Tidak dapat menghapus homedir: %s\n"
 
 #: tools/sss_userdel.c:186
 msgid ""
 "No such user in local domain. Removing users only allowed in local domain.\n"
 msgstr ""
+"Tidak ada pengguna seperti itu di domain lokal. Menghapus pengguna hanya "
+"diperbolehkan dalam domain lokal.\n"
 
 #: tools/sss_userdel.c:191
 msgid "Internal error. Could not remove user.\n"
-msgstr ""
+msgstr "Kesalahan internal. Tidak dapat menghapus pengguna.\n"
 
 #: tools/tools_util.c:292
 msgid "Out of memory\n"
-msgstr ""
+msgstr "Kehabisan memori\n"
 
 #: tools/tools_util.h:34
 #, c-format
 msgid "%s must be run as root\n"
-msgstr ""
+msgstr "%s harus dijalankan sebagai root\n"
 
 #: tools/sss_useradd.c:115 tools/sss_usermod.c:47
 msgid "The UID of the user"
-msgstr ""
+msgstr "UID dari pengguna"
 
 #: tools/sss_useradd.c:116
 msgid "The GID or group name of the user"
-msgstr ""
+msgstr "GID atau nama grup pengguna"
 
 #: tools/sss_useradd.c:117 tools/sss_usermod.c:49
 msgid "The comment string"
-msgstr ""
+msgstr "String komentar"
 
 #: tools/sss_useradd.c:118 tools/sss_usermod.c:50
 msgid "Home directory"
-msgstr ""
+msgstr "Direktori Home"
 
 #: tools/sss_useradd.c:119 tools/sss_usermod.c:51
 msgid "Login shell"
-msgstr ""
+msgstr "Shell login"
 
 #: tools/sss_useradd.c:120
 msgid "Groups"
-msgstr ""
+msgstr "Grup"
 
 #: tools/sss_useradd.c:121
 msgid "Create user's directory if it does not exist"
-msgstr ""
+msgstr "Buat direktori pengguna jika tidak ada"
 
 #: tools/sss_useradd.c:122
 msgid "Never create user's directory, overrides config"
-msgstr ""
+msgstr "Jangan pernah buat direktori pengguna, timpa konfigurasi"
 
 #: tools/sss_useradd.c:123
 msgid "Specify an alternative skeleton directory"
-msgstr ""
+msgstr "Tentukan direktori kerangka alternatif"
 
 #: tools/sss_useradd.c:172
 msgid "Specify user to add\n"
-msgstr ""
+msgstr "Tentukan pengguna untuk ditambahkan\n"
 
 #: tools/sss_useradd.c:211 tools/sss_usermod.c:170 tools/sss_usermod.c:197
 msgid "Groups must be in the same domain as user\n"
-msgstr ""
+msgstr "Grup harus berada dalam domain yang sama dengan pengguna\n"
 
 #: tools/sss_useradd.c:219
 #, c-format
 msgid "Cannot find group %s in local domain\n"
-msgstr ""
+msgstr "Tidak dapat menemukan grup %s dalam domain lokal\n"
 
 #: tools/sss_useradd.c:229
 msgid "Cannot get group information for the user\n"
-msgstr ""
+msgstr "Tidak bisa mendapatkan informasi grup untuk pengguna\n"
 
 #: tools/sss_useradd.c:251 tools/sss_usermod.c:153
 msgid "The selected UID is outside the allowed range\n"
-msgstr ""
+msgstr "UID yang dipilih berada di luar rentang yang diizinkan\n"
 
 #: tools/sss_useradd.c:285
 msgid "Cannot get info about the user\n"
-msgstr ""
+msgstr "Tidak bisa mendapatkan info tentang pengguna\n"
 
 #: tools/sss_useradd.c:299
 msgid "User's home directory already exists, not copying data from skeldir\n"
 msgstr ""
+"Direktori home milik pengguna sudah ada, tidak menyalin data dari skeldir\n"
 
 #: tools/sss_useradd.c:302
 #, c-format
 msgid "Cannot create user's home directory: %s\n"
-msgstr ""
+msgstr "Tidak dapat membuat direktori home milik pengguna: %s\n"
 
 #: tools/sss_useradd.c:313
 #, c-format
 msgid "Cannot create user's mail spool: %s\n"
-msgstr ""
+msgstr "Tidak dapat membuat spool mail milik pengguna: %s\n"
 
 #: tools/sss_useradd.c:325
 msgid "Could not allocate ID for the user - domain full?\n"
-msgstr ""
+msgstr "Tidak dapat mengalokasikan ID untuk pengguna - domain penuh?\n"
 
 #: tools/sss_useradd.c:329
 msgid "A user or group with the same name or ID already exists\n"
-msgstr ""
+msgstr "Pengguna atau grup dengan nama atau ID yang sama sudah ada\n"
 
 #: tools/sss_useradd.c:335
 msgid "Transaction error. Could not add user.\n"
-msgstr ""
+msgstr "Kesalahan transaksi. Tidak dapat menambahkan pengguna.\n"
 
 #: tools/sss_groupadd.c:75
 msgid "Specify group to add\n"
-msgstr ""
+msgstr "Tentukan grup untuk ditambahkan\n"
 
 #: tools/sss_groupadd.c:133
 msgid "Could not allocate ID for the group - domain full?\n"
-msgstr ""
+msgstr "Tidak dapat mengalokasikan ID untuk grup - domain penuh?\n"
 
 #: tools/sss_groupadd.c:137
 msgid "A group with the same name or GID already exists\n"
-msgstr ""
+msgstr "Grup dengan nama atau GID yang sama sudah ada\n"
 
 #: tools/sss_groupadd.c:142
 msgid "Transaction error. Could not add group.\n"
-msgstr ""
+msgstr "Kesalahan transaksi. Tidak dapat menambahkan grup.\n"
 
 #: tools/sss_usermod.c:48
 msgid "The GID of the user"
-msgstr ""
+msgstr "GID pengguna"
 
 #: tools/sss_usermod.c:52
 msgid "Groups to add this user to"
-msgstr ""
+msgstr "Pengguna ini akan ditambahkan ke grup"
 
 #: tools/sss_usermod.c:53
 msgid "Groups to remove this user from"
-msgstr ""
+msgstr "Pengguna ini akan dihapus dari grup"
 
 #: tools/sss_usermod.c:54
 msgid "Lock the account"
-msgstr ""
+msgstr "Kunci akun"
 
 #: tools/sss_usermod.c:55
 msgid "Unlock the account"
-msgstr ""
+msgstr "Buka kunci akun"
 
 #: tools/sss_usermod.c:115
 msgid "Specify user to modify\n"
-msgstr ""
+msgstr "Tentukan pengguna untuk dimodifikasi\n"
 
 #: tools/sss_usermod.c:146
 msgid ""
 "Cannot find user in local domain, modifying users is allowed only in local "
 "domain\n"
 msgstr ""
+"Tidak dapat menemukan pengguna dalam domain lokal, memodifikasi pengguna "
+"hanya diperbolehkan dalam domain lokal\n"
 
 #: tools/sss_usermod.c:241
 msgid "Could not modify user - check if group names are correct\n"
 msgstr ""
+"Tidak bisa memodifikasi pengguna - periksa apakah nama grup sudah benar\n"
 
 #: tools/sss_usermod.c:245
 msgid "Could not modify user - user already member of groups?\n"
 msgstr ""
+"Tidak bisa memodifikasi pengguna - pengguna sudah menjadi anggota kelompok?\n"
 
 #: tools/sss_usermod.c:249
 msgid "Transaction error. Could not modify user.\n"
-msgstr ""
+msgstr "Kesalahan transaksi. Pengguna tidak dapat dimodifikasi.\n"
 
 #: sss_client/pam_sss.c:353
 msgid "Passwords do not match"
-msgstr "Wachtwoorden komen niet overeen"
+msgstr "Kata sandi tidak cocok"
 
 #: sss_client/pam_sss.c:422
 msgid "Offline authentication"
-msgstr ""
+msgstr "Otentikasi luring"
 
 #: sss_client/pam_sss.c:423
 msgid ", your cached password will expire at: "
@@ -678,37 +696,32 @@ msgstr ""
 
 #: sss_client/pam_sss.c:473
 msgid "Offline authentication, authentication is denied until: "
-msgstr ""
+msgstr "Otentikasi luring, otentikasi ditolak sampai:"
 
 #: sss_client/pam_sss.c:500
 msgid "System is offline, password change not possible"
-msgstr ""
+msgstr "Sistem sedang luring, perubahan kata sandi tidak dimungkinkan"
 
 #: sss_client/pam_sss.c:530
-#, fuzzy
 msgid "Password change failed. "
-msgstr "Wachtwoord is verlopen."
+msgstr "Perubahan kata sandi gagal."
 
 #: sss_client/pam_sss.c:531
 msgid "Server message: "
-msgstr ""
+msgstr "Pesan server:"
 
 #: sss_client/pam_sss.c:898
 msgid "New Password: "
-msgstr "Nieuw Wachtwoord: "
+msgstr "Kata Sandi Baru: "
 
 #: sss_client/pam_sss.c:899
 msgid "Reenter new Password: "
-msgstr "Voer nieuw wachtwoord nogmaals in: "
+msgstr "Masukkan lagi kata sandi baru:"
 
 #: sss_client/pam_sss.c:957
 msgid "Password: "
-msgstr "Wachtwoord: "
+msgstr "Kata sandi:"
 
 #: sss_client/pam_sss.c:987
-#, fuzzy
 msgid "Current Password: "
-msgstr "Nieuw Wachtwoord: "
-
-#~ msgid "Password has expired."
-#~ msgstr "Wachtwoord is verlopen."
+msgstr "Kata sandi saat ini:"
-- 
1.6.6.1