From d5578fa612c53110b2ddaf31b8c8e28d35c7fe9c Mon Sep 17 00:00:00 2001
From: Dmitri Pal <dpal@redhat.com>
Date: Fri, 19 Oct 2012 17:19:33 -0400
Subject: [PATCH 1/2] [INI] Fix doxygen warnings for the interface

This patch fixes the doxygen warnings in the new interface.
---
 ini/ini_configobj.h |   99 ++++++++++++++++++++++++++-------------------------
 1 files changed, 50 insertions(+), 49 deletions(-)

diff --git a/ini/ini_configobj.h b/ini/ini_configobj.h
index bf70528..0ebe17d 100644
--- a/ini/ini_configobj.h
+++ b/ini/ini_configobj.h
@@ -559,7 +559,7 @@ void ini_config_free_errors(char **errors);
  * a provided file.
  *
  * @param[in]  file             File or stream to send errors to.
- * @param[in]  errors           Array of error strings.
+ * @param[in]  error_list       Array of error strings.
  *
  */
 void ini_config_print_errors(FILE *file, char **error_list);
@@ -931,21 +931,21 @@ int ini_get_int_config_value(struct value_obj *vo,
                              int *error);
 
 /**
- * @brief Convert item value to unsigned number.
+ * @brief Convert value object to a unsigned number.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an unsigned number. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  * If "strict" parameter is non zero the function will fail
  * if there are more characters after the last digit.
  * The value range is from 0 to UINT_MAX.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  strict           Fail the function if
@@ -1115,21 +1115,21 @@ int32_t ini_get_int32_config_value(struct value_obj *vo,
                                    int *error);
 
 /**
- * @brief Convert item value to uint32_t number.
+ * @brief Convert value to uint32_t number.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration value
  * into an uint32_t number. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  * If "strict" parameter is non zero the function will fail
  * if there are more characters after the last digit.
  * The value range is from 0 to ULONG_MAX.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  strict           Fail the function if
@@ -1160,21 +1160,21 @@ uint32_t ini_get_uint32_config_value(struct value_obj *vo,
                                      int *error);
 
 /**
- * @brief Convert item value to integer number.
+ * @brief Convert value to integer number.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an int64_t number. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  * If "strict" parameter is non zero the function will fail
  * if there are more characters after the last digit.
  * The value range is from LLONG_MIN to LLONG_MAX.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  strict           Fail the function if
@@ -1205,21 +1205,21 @@ int64_t ini_get_int64_config_value(struct value_obj *vo,
                                    int *error);
 
 /**
- * @brief Convert item value to integer number.
+ * @brief Convert value to integer number.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an uint64_t number. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  * If "strict" parameter is non zero the function will fail
  * if there are more characters after the last digit.
  * The value range is from 0 to ULLONG_MAX.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  strict           Fail the function if
@@ -1250,20 +1250,20 @@ uint64_t ini_get_uint64_config_value(struct value_obj *vo,
                                      int *error);
 
 /**
- * @brief Convert item value to floating point number.
+ * @brief Convert value to floating point number.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into a floating point number. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  * If "strict" parameter is non zero the function will fail
  * if there are more characters after the last digit.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  strict           Fail the function if
@@ -1293,18 +1293,18 @@ double ini_get_double_config_value(struct value_obj *vo,
                                    int *error);
 
 /**
- * @brief Convert item value into a logical value.
+ * @brief Convert value into a logical value.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into a Boolean. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  def              Default value to use if
@@ -1330,13 +1330,14 @@ unsigned char ini_get_bool_config_value(struct value_obj *vo,
                                         int *error);
 
 /**
- * @brief Get string configuration value
+ * @brief Get the copy of string stored in the configuration value
  *
- * Function creates a copy of the string value stored in the item.
+ * Function creates a copy of the string value stored in
+ * the configuration element.
  * Returned value needs to be freed after use.
  * If error occurred the returned value will be NULL.
  *
- * @param[in]  item             Item to use.
+ * @param[in]  vo               Value object to use.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[out] error            Variable will get the value
@@ -1355,13 +1356,13 @@ unsigned char ini_get_bool_config_value(struct value_obj *vo,
 char *ini_get_string_config_value(struct value_obj *vo,
                                   int *error);
 /**
- * @brief Function returns the string stored in the item.
+ * @brief Get the string stored in the configuration value
  *
  * Function returns a reference to the string value
- * stored inside the item. This string can't be altered.
- * The string will go out of scope if the item is deleted.
+ * stored inside the configuration element. This string can't be altered.
+ * The string will go out of scope if the value object is deleted.
  *
- * @param[in]  item             Item to use.
+ * @param[in]  vo               Value object to use.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[out] error            Variable will get the value
@@ -1374,21 +1375,21 @@ char *ini_get_string_config_value(struct value_obj *vo,
  *                              - 0 - Success.
  *                              - EINVAL - Argument is invalid.
  *
- * @return String from the item.
+ * @return String from the value object.
  */
 const char *ini_get_const_string_config_value(struct value_obj *vo,
                                               int *error);
 
 /**
- * @brief Convert item value into a binary sequence.
+ * @brief Convert value into a binary sequence.
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into a sequence of bytes.
  * Any of the conversion functions
  * can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
@@ -1406,7 +1407,7 @@ const char *ini_get_const_string_config_value(struct value_obj *vo,
  *
  * Example: '0a2BFeCc'
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[out] length           Variable that optionally receives
@@ -1447,10 +1448,10 @@ void ini_free_bin_config_value(char *bin);
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration value object
  * into an array of strings. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
@@ -1471,7 +1472,7 @@ void ini_free_bin_config_value(char *bin);
  * it is safe not to get size and just loop until
  * array element is NULL.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  sep              String cosisting of separator
@@ -1506,10 +1507,10 @@ char **ini_get_string_config_array(struct value_obj *vo,
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an array of strings. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
@@ -1530,7 +1531,7 @@ char **ini_get_string_config_array(struct value_obj *vo,
  * it is safe not to get size and just loop until
  * array element is NULL.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[in]  sep              String cosisting of separator
@@ -1565,10 +1566,10 @@ char **ini_get_raw_string_config_array(struct value_obj *vo,
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an array of long values. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
@@ -1581,7 +1582,7 @@ char **ini_get_raw_string_config_array(struct value_obj *vo,
  *
  * Use \ref ini_free_long_config_array() to free the array after use.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[out] size             Variable that receives
@@ -1611,10 +1612,10 @@ long *ini_get_long_config_array(struct value_obj *vo,
  *
  * This is a conversion function.
  * It converts the value read from the INI file
- * and stored in the configuration item
+ * and stored in the configuration element
  * into an array of floating point values. Any of the conversion
  * functions can be used to try to convert the value
- * stored as a string inside the item.
+ * stored as a string inside the value object.
  * The result can be different depending upon
  * how the caller tries to interpret the value.
  *
@@ -1627,7 +1628,7 @@ long *ini_get_long_config_array(struct value_obj *vo,
  *
  * Use \ref ini_free_double_config_array() to free the array after use.
  *
- * @param[in]  item             Item to interpret.
+ * @param[in]  vo               Value object to interpret.
  *                              It must be retrieved using
  *                              \ref ini_get_config_valueobj().
  * @param[out] size             Variable that receives
-- 
1.7.1